/*
btspltrt.c Version 0.1.0  Btree split root node
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/* See btsplit.c for splitting non-root node */

#include <bthash.h>

void btspltrt(bthdr)
btreefmt *bthdr;
   {
   bt_nodefmt *node;
   unsigned char *p,*q,*r;

   bthdr->reason = 0;
   bthdr->ofstleft = btnewblk(bthdr);
   if (bthdr->reason) return;
   p = (unsigned char *) bthdr->blk + bthdr->blkhdr; 
   q = (unsigned char *) bthdr->blk + bthdr->midofst;
   r = (unsigned char *) bthdr->blkleft + bthdr->blkhdr; 
   while (p < q) *r++ = *p++;
   node = (bt_nodefmt *) p = (unsigned char *)
      bthdr->blk + bthdr->midofst;
   bthdr->blkleft->right = (off_t) node->left;
   bthdr->blkleft->count = bthdr->nodesz >> 1;
   btputblk(bthdr,bthdr->ofstleft,bthdr->blkleft);
   if (bthdr->reason) return;
   p = (unsigned char *) bthdr->blkleft; 
   q = (unsigned char *) p + bthdr->blksz;
   while (p < q) *p++ = '\0';

   bthdr->ofstrght = btnewblk(bthdr);
   if (bthdr->reason) return;
   p = (unsigned char *) bthdr->blk + bthdr->midofst
      + bthdr->rcdnode; 
   q = (unsigned char *) bthdr->blk + bthdr->blksz;
   r = (unsigned char *) bthdr->blkrght + bthdr->blkhdr; 
   while (p < q) *r++ = *p++;
   bthdr->blkrght->right = (off_t) bthdr->blk->right;
   bthdr->blkrght->count = bthdr->nodesz >> 1;
   btputblk(bthdr,bthdr->ofstrght,bthdr->blkrght);
   if (bthdr->reason) return;
   p = (unsigned char *) bthdr->blkrght; 
   q = (unsigned char *) p + bthdr->blksz;
   while (p < q) *p++ = '\0';

   p = (unsigned char *) bthdr->blk + bthdr->midofst; 
   q = (unsigned char *) p + bthdr->rcdnode;
   r = (unsigned char *) bthdr->blk + bthdr->blkhdr; 
   while (p < q) *r++ = *p++;
   p = (unsigned char *) r;
   q = (unsigned char *) bthdr->blk + bthdr->blksz;
   while (p < q) *p++ = '\0';
   bthdr->blk->count = 1;
   node = (bt_nodefmt *) p = (unsigned char *)
      bthdr->blk + bthdr->blkhdr;
   node->left = bthdr->ofstleft;
   bthdr->blk->right = bthdr->ofstrght;
   btputblk(bthdr,ROOT,bthdr->blk);
   bthdr->ofstleft = (off_t) 0;
   bthdr->ofstrght = (off_t) 0;
   } /* btspltrt */
